"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("../utils");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BasicModel =
/*#__PURE__*/
function () {
  function BasicModel(tagName, attrs) {
    var _this = this;

    _classCallCheck(this, BasicModel);

    _defineProperty(this, "attributes", void 0);

    _defineProperty(this, "attributes", {});

    _defineProperty(this, "toJson", function () {
      return _objectSpread({}, _this.attributes);
    });

    var ui = attrs.ui || this.getDefaultUI();
    var type = attrs.type || tagName;
    this.attributes = _objectSpread({}, attrs, {
      ui: ui,
      title: attrs.title || '',
      description: attrs.description || '',
      uiParams: attrs.uiParams || {},
      type: type,
      packageName: attrs.packageName || _utils.componentMap.get(type, ui)
    });
  }

  _createClass(BasicModel, [{
    key: "getDefaultUI",
    value: function getDefaultUI() {
      return 'default';
    }
  }, {
    key: "withToolBar",
    value: function withToolBar(children) {
      var toolbar = children.find(function (child) {
        return child.__TOOLBAR__;
      });

      if (toolbar) {
        this.attributes = _objectSpread({}, this.attributes, {
          toolbar: toolbar
        });
      }
    }
  }]);

  return BasicModel;
}();

exports.default = BasicModel;