"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var PageModel =
/*#__PURE__*/
function () {
  // babel bug

  /*::
  items: CannerSchema | {[string]: CannerSchema};
  keyName: string;
  title: string;
  */
  function PageModel(_ref, children) {
    var _this = this;

    var keyName = _ref.keyName,
        title = _ref.title;

    _classCallCheck(this, PageModel);

    if (!keyName) {
      throw new Error('The keyName of <page /> is required');
    }

    this.keyName = keyName;

    if (children && children.length) {
      this.items = children.reduce(function (result, child) {
        if (child.keyName in result) {
          throw new Error("duplicated name in children of ".concat(_this.keyName));
        }

        result[child.keyName] = child;
        return result;
      }, {});
    }

    this.title = title;
  }

  _createClass(PageModel, [{
    key: "toJson",
    value: function toJson() {
      return {
        keyName: this.keyName,
        type: 'page',
        items: this.items,
        title: this.title
      };
    }
  }]);

  return PageModel;
}();

exports.default = PageModel;